require 'estatic/version'
require 'estatic/generator'
require 'estatic/configuration'
require 'estatic/resource'
require 'estatic/category'
require 'estatic/subcategory'
require 'estatic/page_generator'
require 'estatic/page'
require 'estatic/product_listings_page'
require 'estatic/product_page'
require 'estatic/home_page'
require 'estatic/csv_parser'
require 'tilt'
require 'haml'
require 'slim'
require 'csv'
require 'ostruct'
require 'json'
require 'fileutils'
require 'logger'

module Estatic
  module_function

  def root
    File.dirname __dir__
  end

  def logger
    @logger ||= Logger.new(STDOUT).tap do |logger|
      logger.formatter = proc do |severity, datetime, progname, msg|
        "#{severity + ': ' if severity == 'ERROR'}#{msg}\n"
      end
    end
  end

  def configure
    yield configuration
  end

  def configuration
    @configuration ||= Configuration.new
  end

  def generate
    generator = Generator.new
    generator.run
  end

  def csv_files
    @csv_files ||= Dir.glob("#{Estatic.configuration.project_path}/blueprints/csv/*.csv")
  end

  def templates
    @templates ||= Dir.glob("#{Estatic.configuration.project_path}/blueprints/*.{erb,haml,slim}")
  end
end
