module Estatic
  class Page
    attr_accessor :resource

    def initialize(resource)
      @resource = resource
    end

    def content
      Tilt.new(template).render(self, resource.locals)
    end

    private

    def template
      Estatic.templates.detect { |file| File.basename(file, '.*') == class_name }
    end

    def class_name
      self.class.name.split('::').last.gsub(/(.)([A-Z](?=[a-z]))/,'\1_\2').downcase
    end
  end
end
