module Estatic
  class ProductListingsPage < Page
    attr_reader :products, :current_page, :total_pages

    def initialize(resource, page_number)
      super(resource)
      @products = resource.products_in_chunks[page_number - 1]
      @current_page = page_number
      @total_pages = resource.total_chunks
    end

    def filename
      current_page == 1 ? 'index.html' : "#{current_page}.html"
    end

    def render(filename, args = {})
      partial = Dir.glob("#{Estatic.configuration.project_path}/blueprints/shared/#{filename}.{erb,haml,slim}").first
      Tilt.new(partial).render(nil, args[:locals])
    end
  end
end
