module Estatic
  class Subcategory < Resource
    attr_reader :category_name, :products

    def initialize(name, category_name)
      super(name)
      @category_name = category_name
      @products = get_products
    end

    def has_subcategories?
      false
    end

    def get_products
      products = CSVParser.parse(name)
      products.map { |attributes| OpenStruct.new product(attributes) }
    end

    def directory
      File.join(Estatic.configuration.estatic_site_path, category_name, name)
    end

    def root_path
      '../../'.freeze
    end
  end
end
